#!/bin/bash
# Usage:

function validate {
    if grep "FROMIB COMPLETE     20 SWITCHTABLE" $1.STARSxrefs > /dev/null; then
        if grep "FROMIB COMPLETE      1 RETURNTARGET" $1.STARSxrefs > /dev/null; then
            if tail $1.infoannot | grep "SUCCESS ANALYSISCOMPLETED" > /dev/null; then
                echo "STARS success"
                exitstatus=0
            else
                echo "Failed to find SUCCESS ANALYSISCOMPLETED annotation"
                exitstatus=1
            fi
        else
            echo "Failed to find any COMPLETE RETURNTARGET xref annotations"
            exitstatus=2
        fi
    else
        echo "Failed to find COMPLETE 20 SWITCHTABLE xref annotation"
        exitstatus=3
    fi
    return $exitstatus
}

function test {
    . $SMPSA_HOME/SMP-fullanalyze64-ida7.sh $1
    validate $1
}

# Pass in optimization level string, e.g. O0, Og, or O3
function build {
    rm -f starstest_$1.exe
    gcc -m64 -$1 -o starstest_$1.exe $SMPSA_HOME/tests/starstest.c
}

# Pass in optimization level string, e.g. O0, Og, or O3
function build_and_test {
    build $1
    test starstest_$1.exe
}

#!/bin/bash
set -e
set -x

cd $CICD_MODULE_WORK_DIR/stars_umbrella
source set_env_vars
cd /tmp

# Build and test each of the optimization levels -O0, -Og, and -O3.
if build_and_test O0 ; then
    if build_and_test Og ; then
        build_and_test O3
    fi
fi


