#ifndef STARSIRDBProgram_h
#define STARSIRDBProgram_h

// #include <map>
// #include <set>
// #include <string>

// #include <cstdint>
// #include <cstdio>

#include <irdb-core>

#include "interfaces/STARSTypes.h"
#include "interfaces/abstract/STARSProgram.h"

class STARS_IRDB_Program_t : public STARS_Program_t {
public:
	STARS_IRDB_Program_t(IRDB_SDK::FileIR_t* p_firp) : m_firp(p_firp) {}
	// Data initialization
	void DetermineRootFileName(void);
	bool OpenFiles(void);
	void CloseFiles(void);
	virtual bool OpenMainAnnotationFile(void) { return STARS_Program_t::OpenMainAnnotationFile(); };
	virtual bool OpenSecondaryFilesOnly(void) { return STARS_Program_t::OpenSecondaryFilesOnly(); };

	// Get (accessor) methods

	// Set (mutator) methods

	// Query methods

	// Analysis methods
	void ReportTotalCodeSize(unsigned long long TotalCodeSize);
	void InitStaticDataTable(SMPProgram *CurrProg);

	virtual void PrintAllCodeToCodeXrefs(STARS_ea_t, std::size_t, bool CallFlag, bool CompleteIndirCall) {}
	virtual void GetBlockSuccessorTargets(bool, STARS_InstructionID_t, std::size_t, std::list<STARS_InstructionID_t>&);
	virtual void FindCodeAddressesTaken(SMPProgram *CurrProg) { return; };


private:
	// Data

	FILE *SMPLogFile;

	// Methods

	IRDB_SDK::FileIR_t* m_firp;	
	
};

#endif
